from __future__ import annotations
from typing import Any, Protocol, runtime_checkable
from com.sun.star.uno import XInterface

@runtime_checkable
class XSearchable(XInterface, Protocol):
    def createSearchDescriptor(self) -> XSearchDescriptor: ...
    def findAll(self, xDesc: XSearchDescriptor) -> XIndexAccess: ...
    def findFirst(self, xDesc: XSearchDescriptor) -> XInterface: ...
    def findNext(self, xStartAt: XInterface, xDesc: XSearchDescriptor) -> XInterface: ...
